(ns znuli.gif
  (:import GifSequenceWriter)
  (:gen-class))

(import
  '(java.io FileOutputStream FileInputStream File)
  '(javax.imageio.stream ImageOutputStream ImageInputStream
    FileImageOutputStream)
  '(javax.imageio ImageIO)
  '(java.util Date)
  '(java.text SimpleDateFormat))

(defn create-gif [pictures ms-per-frame loop?]
  (let 
    [first-image (ImageIO/read (File. (first pictures)))
     image-type (.getType first-image)
     file-name (str "ani" (.getTime (java.util.Date.)) ".gif")
     out (ImageIO/createImageOutputStream
                (FileOutputStream. file-name)),
     writer (GifSequenceWriter.
              out,
              image-type,
              ms-per-frame,
              loop?)]
    (defn append-to-gif [pictures]
      (cond
        (not (empty? pictures))
          (do (.writeToSequence writer (ImageIO/read (File. (first pictures)))) (recur (rest pictures)))
        true (do (.close writer) (.close out))))
    (append-to-gif pictures)
    (println "wrote" file-name)))

;(create-gif '("./1.png" "./2.png") 60 true)

